/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"time"

	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	scheme "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/generated/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	rest "k8s.io/client-go/rest"
)

// KukuCertsGetter has a method to return a KukuCertInterface.
// A group's client should implement this interface.
type KukuCertsGetter interface {
	KukuCerts(namespace string) KukuCertInterface
}

// KukuCertInterface has methods to work with KukuCert resources.
type KukuCertInterface interface {
	Create(*v1.KukuCert) (*v1.KukuCert, error)
	Update(*v1.KukuCert) (*v1.KukuCert, error)
	Delete(name string, options *metav1.DeleteOptions) error
	DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error
	Get(name string, options metav1.GetOptions) (*v1.KukuCert, error)
	List(opts metav1.ListOptions) (*v1.KukuCertList, error)
	Watch(opts metav1.ListOptions) (watch.Interface, error)
	Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.KukuCert, err error)
	KukuCertExpansion
}

// kukuCerts implements KukuCertInterface
type kukuCerts struct {
	client rest.Interface
	ns     string
}

// newKukuCerts returns a KukuCerts
func newKukuCerts(c *KumoriV1Client, namespace string) *kukuCerts {
	return &kukuCerts{
		client: c.RESTClient(),
		ns:     namespace,
	}
}

// Get takes name of the kukuCert, and returns the corresponding kukuCert object, and an error if there is any.
func (c *kukuCerts) Get(name string, options metav1.GetOptions) (result *v1.KukuCert, err error) {
	result = &v1.KukuCert{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kukucerts").
		Name(name).
		VersionedParams(&options, scheme.ParameterCodec).
		Do().
		Into(result)
	return
}

// List takes label and field selectors, and returns the list of KukuCerts that match those selectors.
func (c *kukuCerts) List(opts metav1.ListOptions) (result *v1.KukuCertList, err error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	result = &v1.KukuCertList{}
	err = c.client.Get().
		Namespace(c.ns).
		Resource("kukucerts").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Do().
		Into(result)
	return
}

// Watch returns a watch.Interface that watches the requested kukuCerts.
func (c *kukuCerts) Watch(opts metav1.ListOptions) (watch.Interface, error) {
	var timeout time.Duration
	if opts.TimeoutSeconds != nil {
		timeout = time.Duration(*opts.TimeoutSeconds) * time.Second
	}
	opts.Watch = true
	return c.client.Get().
		Namespace(c.ns).
		Resource("kukucerts").
		VersionedParams(&opts, scheme.ParameterCodec).
		Timeout(timeout).
		Watch()
}

// Create takes the representation of a kukuCert and creates it.  Returns the server's representation of the kukuCert, and an error, if there is any.
func (c *kukuCerts) Create(kukuCert *v1.KukuCert) (result *v1.KukuCert, err error) {
	result = &v1.KukuCert{}
	err = c.client.Post().
		Namespace(c.ns).
		Resource("kukucerts").
		Body(kukuCert).
		Do().
		Into(result)
	return
}

// Update takes the representation of a kukuCert and updates it. Returns the server's representation of the kukuCert, and an error, if there is any.
func (c *kukuCerts) Update(kukuCert *v1.KukuCert) (result *v1.KukuCert, err error) {
	result = &v1.KukuCert{}
	err = c.client.Put().
		Namespace(c.ns).
		Resource("kukucerts").
		Name(kukuCert.Name).
		Body(kukuCert).
		Do().
		Into(result)
	return
}

// Delete takes name of the kukuCert and deletes it. Returns an error if one occurs.
func (c *kukuCerts) Delete(name string, options *metav1.DeleteOptions) error {
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kukucerts").
		Name(name).
		Body(options).
		Do().
		Error()
}

// DeleteCollection deletes a collection of objects.
func (c *kukuCerts) DeleteCollection(options *metav1.DeleteOptions, listOptions metav1.ListOptions) error {
	var timeout time.Duration
	if listOptions.TimeoutSeconds != nil {
		timeout = time.Duration(*listOptions.TimeoutSeconds) * time.Second
	}
	return c.client.Delete().
		Namespace(c.ns).
		Resource("kukucerts").
		VersionedParams(&listOptions, scheme.ParameterCodec).
		Timeout(timeout).
		Body(options).
		Do().
		Error()
}

// Patch applies the patch and returns the patched kukuCert.
func (c *kukuCerts) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *v1.KukuCert, err error) {
	result = &v1.KukuCert{}
	err = c.client.Patch(pt).
		Namespace(c.ns).
		Resource("kukucerts").
		SubResource(subresources...).
		Name(name).
		Body(data).
		Do().
		Into(result)
	return
}
